summaryrefslogtreecommitdiff
path: root/resources/scripts/build
diff options
context:
space:
mode:
authorLeah Rowe <leah@libreboot.org>2022-11-11 21:38:12 +0000
committerGogs <gogitservice@gmail.com>2022-11-11 21:38:12 +0000
commitb5c25efed46f0a9121023997c6758eda5c3f5017 (patch)
tree973bda08e84b61b8fee442a94db1bc62bd6d818a /resources/scripts/build
parentfbbb5bc616b08a5cd747735b0612fd0f0046c7fe (diff)
parent61ac6c3f0b26deadc2fb8355a8dd0d25b29baacd (diff)
Merge branch 'u-boot-chromebooks' of alpernebbi/lbmk into master
Diffstat (limited to 'resources/scripts/build')
-rwxr-xr-xresources/scripts/build/boot/roms_helper80
-rwxr-xr-xresources/scripts/build/payload/u-boot146
-rwxr-xr-xresources/scripts/build/release/u-boot-libre10
3 files changed, 225 insertions, 11 deletions
diff --git a/resources/scripts/build/boot/roms_helper b/resources/scripts/build/boot/roms_helper
index a6b64316..951e19ba 100755
--- a/resources/scripts/build/boot/roms_helper
+++ b/resources/scripts/build/boot/roms_helper
@@ -4,6 +4,7 @@
#
# Copyright (C) 2020,2021 Leah Rowe <info@minifree.org>
# Copyright (C) 2021 Vitali64 <vitali64pmemail@protonmail.com>
+# Copyright (C) 2022 Alper Nebi Yasak <alpernebiyasak@gmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
@@ -63,6 +64,8 @@ payload_seabios="n"
payload_seabios_withgrub="n" # i386-coreboot grub accessible from SeaBIOS boot menu
seabios_opromloadonly="0"
payload_memtest="n"
+payload_uboot="n"
+uboot_config="undefined"
# Override the above defaults using board.cfg
source "resources/coreboot/${board}/board.cfg"
@@ -109,7 +112,7 @@ fi
# NOTE: reverse logic must not be applied. If SeaBIOS-with-GRUB works, that doesn't
# necessarily mean GRUB-with-SeaBIOS will work nicely. for example, the board might
# only have an add-on GPU available, where it's recommended to boot SeaBIOS first
-if [ "${payload_grub}" != "y" ] && [ "${payload_seabios}" != "y" ]; then
+if [ "${payload_grub}" != "y" ] && [ "${payload_seabios}" != "y" ] && [ "${payload_uboot}" != "y" ]; then
while true; do
for configfile in "resources/coreboot/${board}/config/"*; do
if [ -f "${configfile}" ]; then
@@ -121,6 +124,16 @@ if [ "${payload_grub}" != "y" ] && [ "${payload_seabios}" != "y" ]; then
done
fi
+if [ "${payload_uboot}" != "n" ] && \
+ [ "${payload_uboot}" != "y" ]; then
+ payload_uboot="n"
+fi
+
+if [ "${payload_uboot}" = "y" ] && \
+ [ "${uboot_config}" = "undefined" ]; then
+ uboot_config="default"
+fi
+
if [ "${payload_memtest}" = "y" ]; then
if [ ! -f "memtest86plus/memtest" ]; then
./build module memtest86plus
@@ -150,13 +163,17 @@ if [ "${arch}" = "x86_32" ] || [ "${arch}" = "x86_64" ]; then
)
fi
elif [ "${arch}" = "ARMv7" ]; then
- cat version > "${cbdir}/.coreboot-version"
- cd "${cbdir}"
- make crossgcc-arm CPUS=$(nproc) # This is for armv7, doesn't apply to aarch64
+ (
+ cat version > "${cbdir}/.coreboot-version"
+ cd "${cbdir}"
+ make crossgcc-arm CPUS=$(nproc) # This is for armv7, doesn't apply to aarch64
+ )
elif [ "${arch}" = "AArch64" ]; then
- cat version > "${cbdir}/.coreboot-version"
- cd "${cbdir}"
- make crossgcc-aarch64 CPUS=$(nproc) # This is for aarch64, doesn't apply to armv7
+ (
+ cat version > "${cbdir}/.coreboot-version"
+ cd "${cbdir}"
+ make crossgcc-arm crossgcc-aarch64 CPUS=$(nproc) # This is for aarch64, doesn't apply to armv7
+ )
fi
if [ ! -f "${cbfstool}" ]; then
@@ -211,6 +228,21 @@ if [ "${payload_grub}" = "y" ] || [ "${payload_seabios_withgrub}" = "y" ]; then
done
fi
+if [ "${payload_uboot}" = "y" ]; then
+ if [ "${uboot_config}" = "default" ] && \
+ [ -f "payload/u-boot/${board}/u-boot.elf" ]; then
+ ubootelf="payload/u-boot/${board}/u-boot.elf"
+ else
+ ubootelf="payload/u-boot/${board}/${uboot_config}/u-boot.elf"
+ fi
+
+ if [ ! -f "${ubootelf}" ]; then
+ printf "Required U-Boot payloads not yet built. Building now:\n"
+ rm -Rf "payload/u-boot/${board}" # just in case
+ ./build payload u-boot "${board}"
+ fi
+fi
+
# it is assumed that no other work will be done on the ROM
# after calling this function. therefore this function is "final"
moverom() {
@@ -275,6 +307,7 @@ mkCoreboot() {
make distclean
)
cp "${cbcfgpath}" "${cbdir}"/.config
+ ./build module cbutils ${cbdir#coreboot/}
(
cd "${cbdir}"
make -j$(nproc)
@@ -321,6 +354,28 @@ make_seabios_rom() {
}
# make a rom in /tmp/ and then print the path of that ROM
+make_uboot_payload_rom() {
+ target_cbrom="${1}" # rom to insert u-boot in. this rom won't be touched
+ # a tmpfile will be made instead
+ target_uboot_cbfs_path="${2}" # e.g. fallback/payload
+ target_uboot_config="${3}"
+ cbfstool_path="${4}"
+
+ if [ "${target_uboot_config}" = "default" ]; then
+ target_ubootelf="payload/u-boot/${board}/u-boot.elf"
+ else
+ target_ubootelf="payload/u-boot/${board}/${target_uboot_config}/u-boot.elf"
+ fi
+
+ tmprom=$(mktemp -t coreboot_rom.XXXXXXXXXX)
+
+ cp "${target_cbrom}" "${tmprom}"
+ "${cbfstool}" "${tmprom}" add-payload -f "${target_ubootelf}" -n ${target_uboot_cbfs_path} -c lzma
+
+ printf "%s\n" "${tmprom}"
+}
+
+# make a rom in /tmp/ and then print the path of that ROM
make_grubrom_from_keymap() {
target_keymap="${1}"
target_cbrom="${2}"
@@ -450,6 +505,17 @@ mkRoms() {
if [ "${payload_grub}" = "y" ]; then
mkRomsWithGrub "${corebootrom}" "${initmode}" "${displaymode}" "grub"
fi
+
+ if [ "${payload_uboot}" = "y" ]; then
+ tmpubootrom="$(make_uboot_payload_rom "${corebootrom}" "fallback/payload" "${uboot_config}" "${cbfstool}")"
+ if [ "${initmode}" = "normal" ]; then
+ newrompath="${romdir}/uboot_payload_${board}_${initmode}.rom"
+ else
+ newrompath="${romdir}/uboot_payload_${board}_${initmode}_${displaymode}.rom"
+ fi
+ moverom "${tmpubootrom}" "${newrompath}" "${romtype}"
+ rm -f "${tmpubootrom}"
+ fi
}
initmode="libgfxinit"
diff --git a/resources/scripts/build/payload/u-boot b/resources/scripts/build/payload/u-boot
new file mode 100755
index 00000000..6c94a441
--- /dev/null
+++ b/resources/scripts/build/payload/u-boot
@@ -0,0 +1,146 @@
+#!/usr/bin/env bash
+
+# helper script: builds U-Boot source code
+#
+# Copyright (C) 2020, 2021 Leah Rowe <info@minifree.org>
+# Copyright (C) 2021 Vitali64 <vitali64pmemail@protonmail.com>
+# Copyright (C) 2022 Alper Nebi Yasak <alpernebiyasak@gmail.com>
+#
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program. If not, see <http://www.gnu.org/licenses/>.
+#
+
+[ "x${DEBUG+set}" = 'xset' ] && set -v
+set -u -e
+
+RET=0
+
+# Build U-Boot
+# ---------------------------------------------------------------------
+
+printf "Building U-Boot payloads\n"
+
+# Build for all boards if no argument is given
+if [ "$#" -eq 0 ]; then
+ for board_dir in resources/u-boot/*; do
+ if [ -d "${board_dir}/config/" ]; then
+ set -- "$@" "${board_dir#resources/u-boot/}"
+ fi
+ done
+fi
+
+[ ! -d "payload/" ] && mkdir -p payload/
+[ ! -d "payload/u-boot" ] && mkdir -p payload/u-boot/
+
+# Appends additional version info to U-Boot
+our_version="$(cat version)"
+projectname="$(cat projectname)"
+export LOCALVERSION="-${projectname}-${our_version}"
+
+for board in "$@"; do
+ board_dir="resources/u-boot/${board}"
+ rm -rf "payload/u-boot/${board}"
+ mkdir -p "payload/u-boot/${board}"
+
+ ubtree="undefined"
+ arch="undefined"
+
+ if [ ! -f "${board_dir}/board.cfg" ]; then
+ printf "%s: Target %s does not have a board.cfg. Skipping build.\n" \
+ "build/payload/u-boot" "${board}"
+ RET=1
+ continue
+ fi
+
+ # Override the above defaults using board.cfg
+ source "${board_dir}/board.cfg"
+
+ if [ "${ubtree}" = "undefined" ]; then
+ printf "%s: Target %s does not define a U-Boot tree. Skipping build.\n" \
+ "build/payload/u-boot" "${board}"
+ RET=1
+ continue
+ fi
+ if [ "${arch}" = "undefined" ]; then
+ printf "%s: Target %s does not define a CPU type. Skipping build.\n" \
+ "build/payload/u-boot" "${board}"
+ RET=1
+ continue
+ fi
+
+ ubdir="u-boot/${board}"
+ if [ "${board}" != "${ubtree}" ]; then
+ ubdir="u-boot/${ubtree}"
+ fi
+
+ if [ ! -d "${ubdir}" ]; then
+ ./download u-boot "$board"
+ fi
+
+ if [ ! -d "${ubdir}" ]; then
+ printf "%s: Failed to download U-Boot for target %s. Skipping build.\n" \
+ "build/payload/u-boot" "${board}"
+ RET=1
+ continue
+ fi
+
+ if [ "${arch}" = "x86_32" ] || [ "${arch}" = "x86_64" ]; then
+ export CROSS_COMPILE=x86_64-linux-
+ elif [ "${arch}" = "ARMv7" ]; then
+ export CROSS_COMPILE=arm-linux-gnueabi-
+ elif [ "${arch}" = "AArch64" ]; then
+ export CROSS_COMPILE=aarch64-linux-gnu-
+ fi
+
+ for config in "${board_dir}/config"/*; do
+ if [ ! -f "${config}" ]; then
+ printf "%s: Target %s has no configs to build for. Skipping build.\n" \
+ "build/payload/u-boot" "${board}"
+ RET=1
+ continue
+ fi
+
+ config_name="${config#$board_dir/config/}"
+ if [ "$config_name" = "default" ]; then
+ dest_dir="payload/u-boot/${board}"
+ else
+ dest_dir="payload/u-boot/${board}/${config_name}"
+ fi
+ mkdir -p "${dest_dir}"
+
+ printf "%s: Building for target %s (config %s).\n" \
+ "build/payload/u-boot" "${board}" "${config_name}"
+
+ make -C "${ubdir}" distclean
+
+ cp "${config}" "${ubdir}/.config"
+ make -C "${ubdir}" olddefconfig
+ make -C "${ubdir}" -j"$(nproc)" all
+
+ for f in "${ubdir}"/u-boot{,.bin,.dtb,.img,.itb,.elf}; do
+ if [ -f "$f" ]; then
+ mv "$f" "${dest_dir}/"
+ fi
+ done
+
+ make -C "${ubdir}" distclean
+
+ printf "%s: Built for target %s (config %s).\n" \
+ "build/payload/u-boot" "${board}" "${config_name}"
+ done
+done
+
+printf "Done! U-Boot files are in payload/u-boot/\n\n"
+exit $RET
+
+# ------------------- DONE ----------------------
diff --git a/resources/scripts/build/release/u-boot-libre b/resources/scripts/build/release/u-boot-libre
index a871aab7..8e0ce17c 100755
--- a/resources/scripts/build/release/u-boot-libre
+++ b/resources/scripts/build/release/u-boot-libre
@@ -5,6 +5,7 @@
#
# Copyright (C) 2020,2021 Leah Rowe <info@minifree.org>
# Copyright (C) 2022 Denis 'GNUtoo' Carikli <GNUtoo@cyberdimension.org>
+# Copyright (C) 2022 Alper Nebi Yasak <alpernebiyasak@gmail.com>
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
@@ -23,10 +24,11 @@
[ "x${DEBUG+set}" = 'xset' ] && set -v
set -u -e
-revision="r1"
+revision="r2"
supported_uboot_versions=" \
2021.07 \
+ 2022.07 \
"
topdir="$(realpath $(dirname $(realpath $0))/../../../../)"
@@ -101,7 +103,7 @@ release_deblobbed_uboot()
"${tarball}.xz"
mkdir -p "$(dirname ${tmpdir})"
- cp -R "u-boot/u-boot/" "${tmpdir}"
+ cp -R "u-boot/v${version}/" "${tmpdir}"
rm -rf ${tmpdir}/.git ${tmpdir}/.gitignore
make -C ${tmpdir} distclean
@@ -112,7 +114,7 @@ release_deblobbed_uboot()
--format=gnu \
--sort=name \
--owner=0 --group=0 --numeric-owner \
- --mtime="1970-01-01" \
+ --mtime="@${SOURCE_DATE_EPOCH:-0}" \
lzip -9 --keep -vv "${tarball}"
xz -9 --keep -vv "${tarball}"
@@ -170,7 +172,7 @@ release_uboot_deblob_script()
"${destination}.xz"
install -m 755 -d "${release_version_dir}"
- install -m 644 -T "${blobs_list}" "${destination}"
+ install -m 644 -T "${deblob_script}" "${destination}"
lzip -9 --keep -vv "${destination}"
xz -9 --keep -vv "${destination}"